Subject: bug#78807: 31.0.50; Wave underline set wrongly

From: Ergus <[email-masked]>
Date: Sun, 22 Jun 2025 01:44:39 +0000 (UTC)

Hi Eli:

As far as I know the check for wave underline in terminfo may look for Smulx
I tried: `infocmp -1 | grep -E 'Smulx|Su|cul'` 

and: `tigetstr("Smulx")` in a C snippet 
and none of them return positive.
The function mentions that it uses some heuristics and that may be the problem?

this is my infocmp output in case it helps:
Best,Ergus

    On Monday, June 16, 2025 at 06:17:26 PM GMT+2, Eli Zaretskii <[email-masked]> wrote:   

 > Date: Mon, 16 Jun 2025 17:41:18 +0200
> From:  Ergus via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <[email-masked]>
> 
> I am using emacs on tmux, which does not support wave underline (it
> prints it as normal text)
> 
> echo -e "\e[4:3mThis is normal text in tmux\e[0m"
> 
> When I try
> 
> (display-supports-face-attributes-p '(:underline (:style wave)))
> 
> it returns t, which for tmux it seems like it shouldn't.
> 
> So this makes that faces like `flyspell-incorrect` look like normal text
> and no highlight is visible at all.

I suggest to report this to the developers of tmux: they should make
sure the terminfo entry correctly reflects the actual capabilities
they support.  As you can see in tty_capable_p, Emacs just looks at
the capabilities reported by terminfo.